<?php
/**
 * Use this file to find one .tar or .tgz backup file in the same folder and extract it here.
 */

if(!isset($_GET['download']) AND !isset($_GET['delete'])) {
    ?>
    <!DOCTYPE html>
    <html>
    <head>
        <meta charset="UTF-8">
    </head>
    <body>
    <h1>StageWare® Backup-Wiederherstellung</h1>
    <h2 style="color: red">Best Practices</h2>
    <ol>
        <li>Wenn möglich, dann erstelle immer ein Backup des Live-Shops, auch wenn dieser Fehler beinhaltet.</li>
        <li>Lade alle relevanten Backup-Dateien zur Sicherung auf deinen Computer herunter, bevor du irgendetwas löschst.</li>
        <li>Lösche niemals deinen aktuellen Shop, bevor du sichergestellt hast, dass das Backup so funktioniert, wie du es erwartest.</li>
        <li>Du solltest ein Backup nach Möglichkeit immer in einem leeren Ordner und mit einer neuen Datenbank einspielen und nicht dort, wo sich aktuell dein Live-Shop befindet.</li>
    </ol>
    <p>Du befindest dich aktuell in dem Order <i><?php echo getcwd(); ?></i></p>
    <?php
}

define('FOLDER', '');
define('DATABASE', '/_stage_ware_data/_database');

// Download backup library
if(!realpath('./tcinnovations/php-archive/src/Tar.php')) {
    $url = "https://zwei.gmbh/assets/shopware/restore-library.zip";
    $zipFile = "./extract_backup.zip"; //
    $zipResource = fopen($zipFile, "w");
    /* Get The Zip File From Server */
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_FAILONERROR, true);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($ch, CURLOPT_AUTOREFERER, true);
    curl_setopt($ch, CURLOPT_BINARYTRANSFER,true);
    curl_setopt($ch, CURLOPT_TIMEOUT, 10);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_FILE, $zipResource);
    $page = curl_exec($ch);
    if(!$page) {
        echo "Error :- ".curl_error($ch);
    }
    curl_close($ch);
    /* Open the Zip file */
    $zip = new ZipArchive;
    if($zip->open($zipFile) != "true"){
        echo "Error :- Unable to open the Zip File";
    }
    /* Extract Zip File */
    $zip->extractTo(__DIR__);
    $zip->close();
}

if(!realpath('./tcinnovations/php-archive/src/Tar.php')) {
    ?>
    <p>Fehler: Die Bibliothek zum Entpacken des Archiv konnte nicht gefunden werden.</p>
    <?php
} else {
    foreach (glob(realpath('./tcinnovations/php-archive/src') . '/*.php') as $filename) {
        include_once $filename;
    }
}

$backup = glob('*{.tar,.tgz}', GLOB_BRACE)[0];

if(isset($_GET['clear'])) {
    $excludes = [
        __DIR__ . '/' . $backup,
        __DIR__ . '/tcinnovations',
        __DIR__ . '/extract.php',
        __DIR__ . '/_stage_ware_data',
    ];
    rdelete(__DIR__, $excludes, true);
    ?>
    <p style="color: green">Der Ordner wurde geleert.</p>
    <?php
}

if($backup) {
    if(isset($_GET['extract'])) {
        try {
            /*
            $excludes = [
                __DIR__ . '/' . $backup,
                __DIR__ . '/backup-library',
                __DIR__ . '/extract.php',
                __DIR__ . '/_stage_ware_data',

            ];
            rdelete(__DIR__, $excludes, true);
            */

            $filename = pathinfo($backup, PATHINFO_FILENAME);
            $extension = pathinfo($backup, PATHINFO_EXTENSION);

            $tar = new tcinnovations\PHPArchive\Tar();

            $tar->open($backup);
            $tar->extract(__DIR__);
            ?>
            <p style="color: green">Das Backup <?php echo $backup; ?> wurde entpackt.</p>
            <?php
        } catch(Exception $e) {
            echo $e->getMessage();
        }
        ?>
        <h2>2. Datenbank-Datei herunterladen</h2>
        <?php
        $sqlFile = getDatabase();
        if($sqlFile) {
            ?>
            <a target="_blank" href="?download">Download</a>
            <p>Lade nun das Datenbank Backup herunter, um es über phpMyAdmin zu importieren. Du findest weitere Informationen dazu in der <a target="_blank" href="https://docs.phpmyadmin.net/de/latest/import_export.html#import">phpMyAdmin Dokumentation</a></p>
            <?php
        } else {
            ?>
            <p>Es konnte keine Datenbank-Datei gefunden werden.</p>
            <?php
        }
        ?>

        <h2>Führe nun noch folgende Schritte durch:</h2>
        <p>
            <ol>
                <li>Importiere die Datenbank über phpMyAdmin oder die Server-Konsole</li>
                <li>Prüfe, ob du die Datenbank-Verbindung in der config.php aktualisieren musst</li>
                <li>Prüfe, ob du die RewriteBase in der .htaccess aktualisieren musst</li>
                <li>Logge dich in das Backend ein und prüfe, ob du die Shopeinstellungen aktualisieren muss</li>
                <li>Leere alle Caches und kompiliere die Themes</li>
                <li>Führe eine umfangreiche Prüfung der Funktionalität des Shops durch</li>
            </ol>
        </p>


        <h2>4. Backup-Datei und extract.php löschen</h2>
        <a href="?delete">Backup-Datei und Entpack-Skript löschen</a><br><br>
        <?php

    } elseif(isset($_GET['download'])) {
        $sqlFile = getDatabase();
        $sqlBasename = pathinfo($sqlFile, PATHINFO_BASENAME);

        header('Content-Description: File Transfer');
        header('Content-Type: application/octet-stream');
        header('Content-Disposition: attachment; filename=' . $sqlBasename);
        header('Content-Transfer-Encoding: binary');
        header('Connection: Keep-Alive');
        header('Expires: 0');
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header('Pragma: public');
        header('Content-Length: ' . filesize($sqlFile));

        $file = @fopen($sqlFile,"rb");

        while(!feof($file))
        {
            print(@fread($file, 1024*8));
            ob_flush();
            flush();
        }

//        unlink($sqlFile);
    } elseif(isset($_GET['delete'])) {
        if(file_exists($backup)) {
            unlink($backup);
        }

        if(file_exists(__DIR__ . '/extract.php')) {
            unlink(__DIR__ . '/extract.php');
        }

        if(file_exists(__DIR__ . '/extract_backup.zip')) {
            unlink(__DIR__ . '/extract_backup.zip');
        }

        $databaseFile = getDatabase();
        unlink(getDatabase());

        if(file_exists(__DIR__ . '/tcinnovations')) {
            rdelete(__DIR__ . '/tcinnovations', [], false);
        }

        header("Location: " . str_ireplace(basename(__FILE__), '', explode('?', $_SERVER['REQUEST_URI'])[0]));
        exit();
    } else {
        if(!isset($_GET['clear'])) {
            ?>
            <h2>Optional: Aktuellen Ordner leeren</h2>
            <p>
                <strong>Achtung:</strong><br>
                Hiermit wird der Inhalt des Ordners <i><?=getcwd();?></i> auf dem Server gelöscht.<br>
                Hierbei bleiben nur das Backup und die zum Entpacken nötigen Dateien erhalten.<br>
                Bitte stelle daher sicher, dass hier keine Daten liegen, die du noch benötigst.
            </p>
            <p><i>Wir versuchen weitere Backup-Dateien zu finden und diese nicht zu löschen. Bitte befolge immer die Best Practices.</i></p>
            <div>
                <a href="?clear">Ja, ich möchte alles in diesem Ordner löschen</a>
            </div>
            <br>
            <?php
        }
        ?>
        <h2>1. Backup entpacken</h2>
        <div>
            <a href="?extract"><?php echo $backup; ?> entpacken</a>
        </div>
        <p>Du befindest dich aktuell in dem Order <i><?php echo getcwd(); ?></i></p>
        <p><strong>Achtung:</strong> Wenn der aktuelle Ordner Dateien enthält, dann kann es zu Problemen beim entpacken kommen.</p>

        <?php
    }

} else {
    echo 'Es wurde kein Backup gefunden.';
}
if(!isset($_GET['download']) AND !isset($_GET['delete'])) {
    ?>
    </body>
    <footer>
        <p>-----------------------------------------------------------------------</p>
        <p>Du hast Fragen oder brauchst Hilfe? Unseren Support erreichst du per E-Mail an <a href="mailto:team@zwei.gmbh">team@zwei.gmbh</a>.</p>
    </footer>
    </html>
    <?php
}

function rdelete($dir, $excludes = [], $keepSelf = true)
{
    $dir = realpath($dir);

    if(!$dir OR empty($dir) OR !file_exists($dir)) return false;

    $di = new \RecursiveDirectoryIterator($dir, \FilesystemIterator::SKIP_DOTS);
    $ri = new \RecursiveIteratorIterator($di, \RecursiveIteratorIterator::CHILD_FIRST);

    foreach ( $ri as $file ) {

        if(in_array($file->getRealPath(), $excludes)) {
            continue;
        } else {
            foreach($excludes as $exclude) {
                if(stripos($file->getRealPath(), $exclude) === 0) {
                    continue 2;
                }
            }
        }

        $file->isDir() ?  rmdir($file) : unlink($file);
    }

    if($keepSelf == true) {
        return true;
    }

    is_dir($dir) ? rmdir($dir) : null;

    return true;
}

function getDatabase()
{
    $databasePath = realpath(__DIR__ . DIRECTORY_SEPARATOR . FOLDER . DATABASE);
    return glob($databasePath . '/*{.sql}', GLOB_BRACE)[0];
}
