<?php
/**
 * Use this file to find one .tar.gz backup file in the same folder and extract it here.
 */

define('FOLDER', '');
define('DATABASE', '/_stage_ware_data/_database');

$backup = glob('*{.tar.gz,.tar,.tgz}', GLOB_BRACE)[0];

if($backup) {
    if(isset($_GET['extract'])) {

        $basename = basename($backup, '.tar.gz');

        if(file_exists($basename . '.tar')) {
            unlink($basename . '.tar');
        }

        $p = new PharData($backup);
        $p->decompress(); // creates .tar

        $phar = new PharData($basename . '.tar');
        $phar->extractTo(__DIR__ . DIRECTORY_SEPARATOR . FOLDER);

        unlink($basename . '.tar');
        unlink($basename . '.tar.gz');

        echo 'Extracting ' . $backup . ' complete<br><br>';

        ?>
        <h2>2. Datenbank-Dump herunterladen (optional)</h2>
        <a href="?download">Download</a><br><br>
        <h2>3. Backup-Datei und extract.php löschen</h2>
        <a href="?delete">Beide Dateien löschen</a><br><br>
        <?php

    } elseif(isset($_GET['download'])) {
        $database = glob(__DIR__ . DIRECTORY_SEPARATOR . FOLDER . DATABASE . '/*{.tar.gz}', GLOB_BRACE)[0];

        $basename = basename($database, '.tar.gz');

        if(file_exists(__DIR__ . DIRECTORY_SEPARATOR . FOLDER . DATABASE . DIRECTORY_SEPARATOR . $basename . '.tar')) {
            unlink(__DIR__ . DIRECTORY_SEPARATOR . FOLDER . DATABASE . DIRECTORY_SEPARATOR . $basename . '.tar');
        }

        $p = new PharData($database);
        $p->decompress(); // creates .tar

        if(file_exists(__DIR__ . DIRECTORY_SEPARATOR . FOLDER . DATABASE . DIRECTORY_SEPARATOR . $basename . '.sql')) {
            unlink(__DIR__ . DIRECTORY_SEPARATOR . FOLDER . DATABASE . DIRECTORY_SEPARATOR . $basename . '.sql');
        }

        $phar = new PharData(__DIR__ . DIRECTORY_SEPARATOR . FOLDER . DATABASE . DIRECTORY_SEPARATOR . $basename . '.tar');
        $phar->extractTo(__DIR__ . DIRECTORY_SEPARATOR . FOLDER . DATABASE);

        $size = filesize(__DIR__ . DIRECTORY_SEPARATOR . FOLDER . DATABASE . DIRECTORY_SEPARATOR . $basename . '.sql');

        header('Content-Description: File Transfer');
        header('Content-Type: application/octet-stream');
        header('Content-Disposition: attachment; filename=' . $basename . '.sql');
        header('Content-Transfer-Encoding: binary');
        header('Connection: Keep-Alive');
        header('Expires: 0');
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header('Pragma: public');
        header('Content-Length: ' . $size);

        $file = @fopen(__DIR__ . DIRECTORY_SEPARATOR . FOLDER . DATABASE . DIRECTORY_SEPARATOR . $basename . '.sql',"rb");

        while(!feof($file))
        {
            print(@fread($file, 1024*8));
            ob_flush();
            flush();
        }

        unlink(__DIR__ . DIRECTORY_SEPARATOR . FOLDER . DATABASE . $basename . '.tar');
        unlink(__DIR__ . DIRECTORY_SEPARATOR . FOLDER . DATABASE . $basename . '.sql');
    } elseif(isset($_GET['delete'])) {
        if(file_exists($backup)) {
            unlink($backup);
        }
        if(file_exists('extract.php')) {
            unlink('extract.php');
        }
        ?>
        <h2>Fertig</h2>
        <p>Die Dateien wurden entpackt. Folgen Sie nun weiter der Anleitung.</p>
        <?php
    } else {
        ?>
        <h2>1. Backup entpacken</h2>
        <a href="?extract"><?php echo $backup; ?> entpacken</a>
        <?php
    }

} else {
    echo 'No backup file found';
}