<?php
if(!isset($_GET['download'])) {
?>
<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
</head>
<body>
<?php
}

/**
 * Use this file to find one .tar or .tgz backup file in the same folder and extract it here.
 */

define('FOLDER', '');
define('DATABASE', '/_stage_ware_data/_database');

require_once './backup-library/vendor/autoload.php';

$backup = glob('*{.tar,.tgz}', GLOB_BRACE)[0];

if($backup) {
    if(isset($_GET['extract'])) {

        rdelete(__DIR__, [__DIR__ . 'extract_1.2.3.php/' . $backup], true);

        $filename = pathinfo($backup, PATHINFO_FILENAME);
        $extension = pathinfo($backup, PATHINFO_EXTENSION);

        $tar = new \splitbrain\PHPArchive\Tar();
        $tar->open($backup);
        $tar->extract(__DIR__);

        echo 'Extracting ' . $backup . ' complete<br><br>';

        ?>
        <h2>2. Datenbank-Dump herunterladen (optional)</h2>
        <a target="_blank" href="?download">Download</a><br><br>
        <h2>3. Backup-Datei und extract.php löschen</h2>
        <a href="?delete">Backup-Datei und Entpack-Skript löschen</a><br><br>
        <?php

    } elseif(isset($_GET['download'])) {

        $databasePath = realpath(__DIR__ . DIRECTORY_SEPARATOR . FOLDER . DATABASE);

        $database = glob($databasePath . '/*{.tar,.tgz}', GLOB_BRACE)[0];

        $filename = pathinfo($database, PATHINFO_FILENAME);
        $extension = pathinfo($database, PATHINFO_EXTENSION);

        if($extension == 'tgz' AND file_exists($filename . '.tar')) {
            unlink($filename . '.tar');
        }

        $tar = new \splitbrain\PHPArchive\Tar();
        $tar->open($database);
        $tar->extract($databasePath);

        $sqlFile = glob($databasePath . '/*{.sql}', GLOB_BRACE)[0];
        $sqlBasename = pathinfo($sqlFile, PATHINFO_BASENAME);

        header('Content-Description: File Transfer');
        header('Content-Type: application/octet-stream');
        header('Content-Disposition: attachment; filename=' . $sqlBasename);
        header('Content-Transfer-Encoding: binary');
        header('Connection: Keep-Alive');
        header('Expires: 0');
        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
        header('Pragma: public');
        header('Content-Length: ' . filesize($sqlFile));

        $file = @fopen($sqlFile,"rb");

        while(!feof($file))
        {
            print(@fread($file, 1024*8));
            ob_flush();
            flush();
        }

        unlink($sqlFile);

    } elseif(isset($_GET['delete'])) {
        if(file_exists($backup)) {
            unlink($backup);
        }
        if(file_exists('extract.php')) {
            unlink('extract.php');
        }
        rdelete(__DIR__ . '/backup-library');
        ?>
        <h2>Fertig</h2>
        <p>Das Backup wurde erfolgreich entpackt.</p>
        <h3></h3>
        <?php
    } else {
        ?>
        <h2>1. Backup entpacken</h2>
        <a href="?extract"><?php echo $backup; ?> entpacken</a>
        <p>Achtung: Bevor das Backup entpackt wird, wird automatisch der Inhalt dieses Ordners auf dem Server geleert. Hierbei bleiben nur das Backup und die zum Entpacken nötigen Dateien erhalten. Bitte stelle daher sicher, dass hier keine Daten liegen, die du noch benötigst.</p>
        <?php
    }

} else {
    echo 'No backup file found';
}

function rdelete($dir, $excludes = [], $keepSelf = true)
{
    $excludes = array_merge($excludes, [__DIR__ . '/extract.php', __DIR__. '/backup-library']);

    $dir = realpath($dir);

    if(!$dir OR empty($dir) OR !file_exists($dir)) return false;

    $di = new \RecursiveDirectoryIterator($dir, \FilesystemIterator::SKIP_DOTS);
    $ri = new \RecursiveIteratorIterator($di, \RecursiveIteratorIterator::CHILD_FIRST);

    foreach ( $ri as $file ) {

        if(in_array($file->getRealPath(), $excludes)) {
            continue;
        } else {
            foreach($excludes as $exclude) {
                if(stripos($file->getRealPath(), $exclude) === 0) {
                    continue 2;
                }
            }
        }

        $file->isDir() ?  rmdir($file) : unlink($file);
    }

    if($keepSelf == true) {
        return true;
    }

    is_dir($dir) ? rmdir($dir) : null;

    return true;
}
?>
</body>
</html>